package hrobot

import (
	"time"

	"git.ar21.de/yolokube/sb-server-monitor/hrobot/schema"
)

type converterImpl struct{}

func (c *converterImpl) SbServerFromSchema(source schema.SbServer) *SbServer {
	var sbServer SbServer
	sbServer.Category = source.Category
	sbServer.CatID = source.CatID
	sbServer.Datacenter = source.Datacenter
	sbServer.DatacenterHr = source.DatacenterHr
	sbServer.Description = source.Description
	sbServer.DiskData.General = source.DiskData.General
	sbServer.DiskData.HDD = source.DiskData.HDD
	sbServer.DiskData.NVMe = source.DiskData.NVMe
	sbServer.DiskData.SATA = source.DiskData.SATA
	sbServer.Dist = source.Dist
	sbServer.Hardware.CPU = source.CPU
	sbServer.Hardware.CPUCount = source.CPUCount
	sbServer.Hardware.Drives = source.Drive
	sbServer.Hardware.DrivesCount = source.DriveCount
	sbServer.Hardware.DrivesHr = source.DriveHr
	sbServer.Hardware.DrivesSize = source.DriveSize
	sbServer.Hardware.ECC = source.ECC
	sbServer.Hardware.HighIO = source.HighIO
	sbServer.Hardware.Memory = source.Ram
	sbServer.Hardware.MemorySize = source.RamSize
	sbServer.ID = source.ID
	sbServer.Information = source.Information
	sbServer.Key = source.Key
	sbServer.Name = source.Name
	sbServer.Network.Bandwidth = source.Bandwidth
	sbServer.Network.Traffic = source.Traffic
	sbServer.PriceInformation.FixedPrice = source.FixedPrice
	sbServer.PriceInformation.NextReduce = source.NextReduce
	sbServer.PriceInformation.NextReduceHr = source.NextReduceHr
	sbServer.PriceInformation.NextReduceTimestamp = time.Unix(source.NextReduceTimestamp, 0)
	sbServer.PriceInformation.Price = source.Price
	sbServer.PriceInformation.SetupPrice = source.DiskData.SetupPrice
	sbServer.Specials = source.Specials
	return &sbServer
}
